//---------------------------------------------------------------------------
#ifndef MixKeyWins1H
#define MixKeyWins1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "global.h"
//---------------------------------------------------------------------------
class TMixKey : public TStringList
{
public:
   bool enabled;
   __property AnsiString name      = { read=ShortName };
   __property AnsiString address   = { read=EAddress };
   __property AnsiString keyid     = { read=KeyId };
   __property AnsiString version   = { read=Version };
   __property AnsiString caps      = { read=Caps };

   virtual __fastcall TMixKey();
   virtual __fastcall TMixKey(TMixKey *key);
   virtual __fastcall TMixKey(TStrings *key, bool Enabled=true);
   virtual __fastcall~TMixKey();
   AnsiString __fastcall ShortName();
   AnsiString __fastcall EAddress();
   AnsiString __fastcall KeyId();
   AnsiString __fastcall Version();
   AnsiString __fastcall Caps();
};

class TMixKeyList1 : public TStringList
{
public:
   int shrtLen;
   int addrLen;
   int versLen;
   TStringList *type2;
   virtual __fastcall TMixKeyList1();
   virtual __fastcall TMixKeyList1(AnsiString filename);
   virtual __fastcall TMixKeyList1(TMixKeyList1 *keys);
   virtual __fastcall TMixKeyList1(TStrings *keys);
   virtual __fastcall TMixKeyList1(TMixKey *key);
   virtual __fastcall~TMixKeyList1();
   void __fastcall GetType2(TStrings *Type2);
   void __fastcall SaveToFileBak(AnsiString &docname, int bakcopies);
   void __fastcall LoadFromFile(AnsiString filename);
   int __fastcall AddKeys(TMixKeyList1 *keys);
   int __fastcall AddKeys(TStrings *keys);
   bool __fastcall AddKey(TStrings *key);
   bool __fastcall AddKey(TMixKey *key);
   bool __fastcall DeleteKey(int atPos);

   virtual AnsiString __fastcall KeyDescription(int atPos);
   TMixKey*   __fastcall MixKey(int atPos);
   AnsiString __fastcall ShortName(int atPos);
   AnsiString __fastcall EAddress(int atPos);
   AnsiString __fastcall Version(int atPos);
   AnsiString __fastcall KeyId(int atPos);
   AnsiString __fastcall Caps(int atPos);
};

class TMixKeyWin1 : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TBevel *Bevel5;
	TBevel *Bevel3;
	TBevel *Bevel2;
	TBevel *Bevel1;
	TOfficeButton *DeleteBtn;
	TOfficeButton *HelpBtn;
	TOfficeButton *OkBtn;
	TOfficeButton *ImportBtn;
	TOfficeButton *SaveBtn;
	TOfficeButton *DocsBtn;
	TOfficeButton *RefreshBtn;
	TOfficeButton *DisableBtn;
	TOfficeButton *RequestBtn;
	TOfficeButton *ClearAllBtn;
	TOfficeButton *HideDisBtn;
	TTreeView *TreeView;
	TPopupMenu *PopupMenu;
	TMenuItem *PopDisableItem;
	TMenuItem *N1;
	TMenuItem *Clear1;
	TMenuItem *PopSaveItem;
	TMenuItem *PopRefreshItem;
	TMenuItem *PopImportItem;
	TMenuItem *N3;
	TMenuItem *PopDeleteItem;
	TPopupMenu *PopupMenu2;
	TMenuItem *PubringItem;
	TMenuItem *TypeListItem;
	TMenuItem *ListDocItem;
	TPopupMenu *PopupMenu1;
	TMenuItem *RemailerAlldocsItem;
	TMenuItem *N2;
	TMenuItem *RemailerConfigItem;
	TMenuItem *RemailerKeyItem;
	TMenuItem *RemailerHelpItem;
	TMenuItem *RemailerStatsItem;
	TTimer *Timer1;
	TImageList *ImageList1;
	TImageList *ImageList2;
	TTimer *FlashTimer;
	TMenuItem *PopExpandItem;
	TMenuItem *PopCollapseItem;
	TMenuItem *N4;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall HideDisBtnClick(TObject *Sender);
	void __fastcall ClearAllBtnClick(TObject *Sender);
	void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall DisableBtnClick(TObject *Sender);
	void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall PopExpandItemClick(TObject *Sender);
	void __fastcall PopCollapseItemClick(TObject *Sender);
	void __fastcall SaveBtnClick(TObject *Sender);
	void __fastcall RefreshBtnClick(TObject *Sender);
	void __fastcall DeleteBtnClick(TObject *Sender);
	void __fastcall RemailerDocItemClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall RemailerConfigItemClick(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall ImportBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    AnsiString cap;
    TList *keynodes;
    TMixKeyList1 *keys;
    int curkey,asciiblks;
    TStringList *newkeys,*diskeys;
    Graphics::TBitmap *bmpHideDis,*bmpShowAll;
    bool modified,checksave,initdone,hidedisabled;
	__fastcall TMixKeyWin1(TComponent* Owner);
 	virtual __fastcall ~TMixKeyWin1();
    TMixKey* __fastcall NodeKey(int atPos);
    void __fastcall SetTreeItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree);
    void __fastcall MakeMessage(TStrings *message, AnsiString &addrs, AnsiString &subject);
    void __fastcall EnableDisableBtn(bool enable);
    void __fastcall SetNothingSelected();
    void __fastcall SetHelpBtnPos();
    void __fastcall GenTreeView();
    void __fastcall SetCount(bool clear=false);
    void __fastcall EnableKey(int atPos, bool enable);
    void __fastcall AddKeysImport(TMixKeyList1 *newkeys);
    void __fastcall GetDisables();
    void __fastcall LoadKeys();
    void __fastcall SaveKeys();
    // message functions
    void __fastcall WMSaveBtnClicked(TMessage& Msg);
    void __fastcall WMRefreshBtnClicked(TMessage& Msg);
    void __fastcall WMImportBtnClicked(TMessage& Msg);
    void __fastcall WMDisableBtnClicked(TMessage& Msg);
    void __fastcall WMDeleteBtnClicked(TMessage& Msg);
    void __fastcall WMGetKeyringMenuDat(TMessage& Msg);
     // message map
    BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_SAVEBTNCLICKED,TMessage,WMSaveBtnClicked)
    MESSAGE_HANDLER(WM_REFRESHBTNCLICKED,TMessage,WMRefreshBtnClicked)
    MESSAGE_HANDLER(WM_IMPORTBTNCLICKED,TMessage,WMImportBtnClicked)
    MESSAGE_HANDLER(WM_DISABLEBTNCLICKED,TMessage,WMDisableBtnClicked)
    MESSAGE_HANDLER(WM_DELETEBTNCLICKED,TMessage,WMDeleteBtnClicked)
    MESSAGE_HANDLER(WM_GETKEYRINGMENUDAT,TMessage,WMGetKeyringMenuDat)
    END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TMixKeyWin1 *MixKeyWin1;
//---------------------------------------------------------------------------
#endif
