//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyWins2.h"
#include "MixKeyImpDlgs.h"
#include "MixProbWins2.h"
#include "Mixmaster.h"
#include "FileWin.h"
#include "ImageMods.h"
#include "WipeDlgs.h"
#include "HelpDlgs.h"
#include "Fileman.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "KeyringWins"
#pragma resource "*.dfm"
TMixKeyWin2 *MixKeyWin2=NULL;
const int versLen = 9;
//---------------------------------------------------------------------------
// TMixKey
//---------------------------------------------------------------------------
__fastcall TMixKey2::TMixKey2()
  : TCustomKey()
{
}
//---------------------------------------------------------------------------
__fastcall TMixKey2::TMixKey2(TCustomKey *key)
  : TCustomKey(key)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKey2::TMixKey2(TStrings *key, bool Enabled)
  : TCustomKey(key)
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey2::Version()
{
   return (Count>0?GetToken(3,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey2::Caps()
{
   return (Count>0?GetToken(4,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
// TMixKeyList
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2()
   : TCustomKeyList()
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(AnsiString filename)
   : TCustomKeyList(filename)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(TCustomKeyList *keys)
   : TCustomKeyList(keys)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(TCustomKey *key)
   : TCustomKeyList(key)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(TStrings *keys)
   : TCustomKeyList(keys)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::~TMixKeyList2()
{
   delete type2;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList2::GetType2()
{
   if (!type2) type2 = new TStringList();
   MixGetType2(type2);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList2::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TMixKey2 *key;
   TStringList *newtype2 = new TStringList();
   TStringList *keys = new TStringList();
   newtype2->Sorted = true;
   for (int i=0; i<Count; i++)
   {
      key = Key(i);
      if (!key || key->Count<15) continue;
      keys->Add(key->Text);
      newtype2->Add((key->enabled?"":"#")+PadRight(key->name,shrtLen)+" "+key->address+" "+
         key->keyid+" "+key->version+" "+key->caps);
   }
   ::SaveToFileBak(newtype2,mtyp2txt,bakcopies);
   ::SaveToFileBak(keys,mringtxt,bakcopies);
   modified = false;
   delete newtype2;
   delete keys;
   GetType2();
}
//---------------------------------------------------------------------------
TMixKey2* __fastcall TMixKeyList2::Key(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TMixKey2*)Objects[atPos];
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList2::AddKeys(TCustomKeyList *keys)
{
   return TCustomKeyList::AddKeys(keys);
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList2::AddKeys(TStrings *keys)
{
   int c=0;
   AnsiString desc;
   TStringList *key=new TStringList();
   TStringList *KEYS=new TStringList();
   KEYS->AddStrings(keys);
   while (MixGetNextKey(desc,key,KEYS))
   {
      AddKey(key);
      c++;
   }
   delete KEYS;
   delete key;
   return c;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList2::LoadFromStrings(TStrings *keys)
{
   Clear(); AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList2::AddKey(TStrings *key)
{
   if (!MixKeyDefinately(key)) return false;
   TMixKey2 *KEY = new TMixKey2(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList2::AddKey(TCustomKey *key)
{
   if (!MixKeyDefinately(key)) return false;

   bool enabled;
   TMixKey2 *KEY = new TMixKey2(key);

   if (!type2) GetType2();
   if (InType2(KEY,enabled)) KEY->enabled = enabled;
   else type2->Add((KEY->enabled?"":"#")+KEY->Strings[0]);

   AnsiString shrt=KEY->name,addr=KEY->address,vers=KEY->version;
   AddObject(shrt+","+addr+","+KEY->keyid+","+vers+","+KEY->caps,KEY);
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   modified = true;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList2::InType2(TMixKey2 *key, bool &enabled)
{
   AnsiString keydesc = key->Strings[0];
   if((enabled=type2->IndexOf("#"+keydesc)<0)==true)
      return type2->IndexOf(keydesc)>=0;
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList2::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];

   addr = PadRight(flds->Strings[1],addrLen);
   if (addr[addrLen]!=' ') addr = addr.SubString(1,addrLen-3)+"...";

   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  "+flds->Strings[2]+"  "+
      PadRight(flds->Strings[3],versLen)+"  "+flds->Strings[4];
   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
// TMixKeyWin
//---------------------------------------------------------------------------
__fastcall TMixKeyWin2::TMixKeyWin2(TComponent* Owner)
	: TCustomKeyWin(Owner)
{
   keyringname = "Mixmaster";
   hidedisabled = GetAppIni(MixHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   keys = new TMixKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin2::TMixKeyWin2(TComponent* Owner, TMixKeyList2 *Imports)
	: TCustomKeyWin(Owner)
{
   imports = Imports;
   keyringname = "Mixmaster";
   hidedisabled = GetAppIni(MixHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   keys = new TMixKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin2::~TMixKeyWin2()
{
   MixKeyWin2 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(mringtxt)) zapfile(mringtxt,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(200);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(mringtxt,STATSBAKCOPIES);
   newkeys->Clear();
   SetRedraw(TreeView,0);
   LoadTreeViewQuiet();
   AppProcessMessages();
   SetRedraw(TreeView,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=keynodes->Count) return;

   TTreeNode* node = Node(atPos);
  ((TMixKey2*)node->Data)->enabled = enable;
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   keys->modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::LoadKeys()
{
   initdone = true;
   if (FileExists(mringtxt)) keys->LoadFromFile(mringtxt);
   if (imports && imports->Count) AddKeysImport(imports);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::LoadTreeView()
{
   TTreeNode *node,*cnode;

   ClearTree();
   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      TMixKey2 *KEY = ((TMixKeyList2*)keys)->Key(i);
      if (newkeys->IndexOf(keys->Strings[i])<0 && hidedisabled && !KEY->enabled) continue;

      AnsiString keydesc = keys->KeyDescription(i);
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,KEY);

      node->ImageIndex = KEY->enabled ? 0:1;
      node->SelectedIndex = node->ImageIndex;

      if (newkeys->IndexOf(keys->Strings[i])>=0) SetTreeItemBold(node,true,TreeView);
      keynodes->Add(node);

      keydesc = KEY->Strings[0];
      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   AppProcessMessages();
   delete next;
}
//---------------------------------------------------------------------------
TMixKey2* __fastcall TMixKeyWin2::NodeKey(int atPos)
{
   if (atPos<0 || atPos>=keynodes->Count) return NULL;
   TMixKey2 *key = (TMixKey2*)((TTreeNode*)keynodes->Items[atPos])->Data;
   return key;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::AddKeysImport(TCustomKeyList *NewKeys)
{
   while (!initdone) AppProcessMessages(); // may not be init yet
   newkeys->Text = NewKeys->Text;
   keys->AddKeys(NewKeys);
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   LoadTreeView();
   SetNothingSelected();
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TMixKeyList2 *impkeys = new TMixKeyList2();
   TMixKeyList2 *dupkeys = new TMixKeyList2();
   ImportDir = orgDir = GetAppIni(MixImportDir,MixDir());
   if (ImportMixmasterKeys(this,(TMixKeyList2*)keys,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         Sleep(100);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count && this==MixKeyWin2)
      {
         if (!MixProbWin2) MixProbWin2 = new TMixProbWin2(AppMainForm);//,false);
         MixProbWin2->BringToFront(); AppProcessMessages();
         MixProbWin2->AddKeysImport(dupkeys);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "MixmasterKeys\nMixmasterKeysImp\nMixmasterKeysDup\nRemailerConfig",
      "Mixmaster Key Manager",
      "Mixmaster Keyring Manager"
   );
}
//---------------------------------------------------------------------------
